"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _lodash = _interopRequireDefault(require("lodash"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const getUniqueSymbols = text => text.split('').reduce((acc, symbol) => acc.includes(symbol) ? acc : [...acc, symbol], []);

const codingAlphabet = symbols => {
  const iter = (acc, code, restSymbols) => {
    if (restSymbols.length === 0) {
      return acc;
    }

    if (restSymbols.length === 1) {
      const [symbol] = restSymbols;
      return { ...acc,
        [symbol]: code
      };
    }

    const [leftPart, rightPart] = _lodash.default.chunk(restSymbols, restSymbols.length / 2);

    return { ...iter(acc, `${code}0`, leftPart),
      ...iter(acc, `${code}1`, rightPart)
    };
  };

  const [leftPart, rightPart] = _lodash.default.chunk(symbols, symbols.length / 2);

  return { ...iter({}, '0', leftPart),
    ...iter({}, '1', rightPart)
  };
};

var _default = text => {
  const alphabet = getUniqueSymbols(text);
  const codedAlphabet = codingAlphabet(alphabet);
  return text.split('').map(symbol => codedAlphabet[symbol]).join('');
};

exports.default = _default;